<?php
/*
Plugin Name:	EHT Mantis
Plugin URI:		http://ociotec.com/index.php/2008/04/01/eht-mantis-plugin-para-wordpress/
Description:	This plugin generates links to Mantis issues automatically into your posts/pages.
Author:			Emilio Gonz&aacute;lez Monta&ntilde;a
Version:		0.2
Author URI:		http://ociotec.com/

History:		0.1		First release.
				0.2		Not print the issues resume if the "continue reading" tag is in the post (issue #34).

Setup:
	1) Install the plugin.
	2) Go to the admin menus, and in "Options" panel, select "EHT Manis".
	3) Configure the plugin if you need.

*/

define ("EHT_MANTIS_PLUGIN_NAME", "eht-mantis");
define ("EHT_MANTIS_PLUGIN_TITLE", "EHT Mantis");
define ("EHT_MANTIS_PLUGIN_URL_BASE", get_option ("siteurl") . "/wp-content/plugins/" . EHT_MANTIS_PLUGIN_NAME . "/");
define ("EHT_MANTIS_PLUGIN_URL_BASE_IMAGES", EHT_MANTIS_PLUGIN_URL_BASE . "images/");
define ("EHT_MANTIS_PLUGIN_PATH_BASE", $_SERVER["DOCUMENT_ROOT"] . "/wp-content/plugins/" . EHT_MANTIS_PLUGIN_NAME . "/");
define ("EHT_MANTIS_PLUGIN_PATH_BASE_IMAGES", EHT_MANTIS_PLUGIN_PATH_BASE . "images/");
define ("EHT_MANTIS_PLUGIN_VERSION", "0.2");
define ("EHT_MANTIS_PLUGIN_DESCRIPTION", "Plugin <a href=\"http://ociotec.com/index.php/2008/04/01/eht-mantis-plugin-para-wordpress/\" target=\"_blank\">" . EHT_MANTIS_PLUGIN_TITLE . " v" . EHT_MANTIS_PLUGIN_VERSION . "</a> - Created by <a href=\"http://ociotec.com\" target=\"_blank\">Emilio Gonz&aacute;lez Monta&ntilde;a</a>");
define ("EHT_MANTIS_PLUGIN_SHORT_DESCRIPTION", "<a href=\"http://ociotec.com/index.php/2008/04/01/eht-mantis-plugin-para-wordpress/\" target=\"_blank\">" . EHT_MANTIS_PLUGIN_TITLE . " v" . EHT_MANTIS_PLUGIN_VERSION . "</a> by <a href=\"http://ociotec.com\" target=\"_blank\">Emilio Gonz&aacute;lez Monta&ntilde;a</a>");
define ("EHT_MANTIS_OPTION_URL", EHT_MANTIS_PLUGIN_NAME . "-option-url");
define ("EHT_MANTIS_OPTION_TARGET_NEW", EHT_MANTIS_PLUGIN_NAME . "-option-target-new");
define ("EHT_MANTIS_YES", "yes");
define ("EHT_MANTIS_NO", "no");
define ("EHT_MANTIS_FIELD_ACTION", EHT_MANTIS_PLUGIN_NAME . "-field-action");
define ("EHT_MANTIS_ACTION_UPDATE", "Update");
define ("EHT_MANTIS_SLASH", strstr (PHP_OS, "WIN") ? "\\" : "/");
define ("EHT_MANTIS_ICON", EHT_MANTIS_PLUGIN_URL_BASE_IMAGES . "Mantis.gif");
define ("EHT_MANTIS_FORMAT_LINK", "<A HREF=\"%sview.php?id=%d\" %s>#%d</A>");
define ("EHT_MANTIS_ALL_LINKS_HEADER", "<BR>\n<IMG SRC=\"" . EHT_MANTIS_ICON . "\"><SMALL><B>Mantis links:</B> ");
define ("EHT_MANTIS_ALL_LINKS_LINE_FIRST", "%s");
define ("EHT_MANTIS_ALL_LINKS_LINE", ", %s");
define ("EHT_MANTIS_ALL_LINKS_FOOTER", "<BR>\n" . EHT_MANTIS_PLUGIN_SHORT_DESCRIPTION . "</SMALL><BR>\n");
define ("EHT_MANTIS_CONTINUE_READING_TAG", "class=\"more-link\"");

require_once ("Admin.php");

add_filter ("the_content", "EHTMantisFilterTheContent");

function EHTMantisFilterTheContent ($content)
{
	$continueReading = (strpos ($content, EHT_MANTIS_CONTINUE_READING_TAG) !== false);

	$search = "/([^&])#(\d+)/i";
	preg_match_all ($search, $content, $results);

	if (is_array ($results[1]))
	{
		$optionUrl = get_option (EHT_MANTIS_OPTION_URL);
		$optionTargetNew = get_option (EHT_MANTIS_OPTION_TARGET_NEW);
		$target = (($optionTargetNew == EHT_MANTIS_YES) ? " TARGET=\"_blank\"" : "");
		$links = array ();
		
		for ($m = 0; $m < count ($results[0]); $m++)
		{
			$previous = $results[1][$m];
			$id = trim ($results[2][$m]);
			
			$links[$m] = sprintf (EHT_MANTIS_FORMAT_LINK,
								  $optionUrl,
								  $id,
								  $target,
								  $id);
			$text = $previous . $links[$m];

			$content = str_replace ($results[0][$m], $text, $content); 
		}
		
		if ((count ($links) > 0) && (!$continueReading))
		{
			$content .= EHT_MANTIS_ALL_LINKS_HEADER;
			$first = true;
			foreach ($links as $link)
			{
				$content .= sprintf (($first ? EHT_MANTIS_ALL_LINKS_LINE_FIRST : EHT_MANTIS_ALL_LINKS_LINE), $link);	
				$first = false;
			}
			$content .= EHT_MANTIS_ALL_LINKS_FOOTER;
		}
	}
	
	return ($content);
}

?>